// Version KEAterm 3.10 $RCSfile: apxhelp.ktm,v $  $Revision: 1.1 $ 
// ============================================================================
// ApxHelp:     This Macro is automatically executed instead of the standard
//              APPX Help text popup screen.  It functions slightly different
//              from the other macros in that the help text is read in after
//              the marco starts instead of being passed in at the beginning.
//
// [ Passed Information ]
//
//              No Information is passed to this macro.
//
// [ ReadIn Information ]
//
//  {Option 81} This is a hidden APPX option on the hidden KEAterm Help Text
//              image of the Help popup.  After initiating HELP, {Option 81}
//              will send the following stream information to your KEAterm
//              session.  All Records are of the following format:
//              [Start of Record] = "$START$ "      Length = 8
//              [Record Type]     =                 Length = 8
//              [Record Data]     =                 Length = variable
//              [End of Record]   = " $STOP$"       Length = 7
//
//  Record ID   Data Value
//  ---------   ---------------------------------------------------------------
//  HEADER      Descriptive of Name Field/Process the Help Text is about.
//  TEXT        One formatted line of help text. (6 - 18 TEXT records)
//  TRAILER     "Y" if Help Edit Allowed, "N" Help Edit NOT Allowed.
//
// ============================================================================

    Global ButtonHelp
        If ButtonHelp = ""
            ButtonHelp = Buttons
        End

    Var Counter = 0
    Var Width   = 0
    Var Type    = ""
    Var Value   = ""
    Var Name    = ""
    Var Text    = ""    // Array of ( 6 - 18 ) elements //
    Var Edit    = ""

//
//  Send HIDDEN option 81) to Help Process and Capture Resulting
//  Help Text (Formatted).
//

    Begin
        ApxOpt( "81)" )
        Suspend( )
    When Match( "$START$*$STOP$", Pat_RegExp, true)
        Type = SubStr( Result, 9, 8 )
        If Len(result) > 23
            Value = SubStr( Result, 17, len(result)-23 )
        Else
            Value = " "
        End
        If Type = "HEADER  "
            Name = Value
            Continue
        ElseIf Type = "TEXT    "
            Counter = Counter + 1
            Text[Counter] = Value
            If Len(Value) > Width
                Width = Len(Value)
            End
            Continue
        ElseIf Type = "TRAILER "
            If Value = "Y"
                Edit = Control_Enable
            else
                Edit = Control_Disable
            end
            Width    = Width   + 2
            Counter  = Counter + 3
        End
    End

//
//  Display Help Dialog Box
//

    Buttons=false
    Begin Dialog( Name ) 
        ListBox( "Help Text", Mode, Text, Width, Counter ) 
        GroupBox( Row=true ) 
            Button( "OK" ) 
            Button( "Edit" ) 
        GroupEnd( ) 
    Do 
        ControlSet( "OK", Control_Focus ) 
        ControlSet( "Edit", Edit )
        Continue 
    When Control( "OK" ) 
        SendKey( AppxKey["Return"] ) 
        Buttons    = ButtonHelp
        ButtonHelp = ""
    When Control( "Edit" ) 
        SendKey( AppxKey["ChangeMode"] ) 
    End 

//  [End of Macro]

